<?php
 /* Master password addon - improved
  * Automated install / update & config functions
  * by @BrockleyJohn john@sewebsites.net
  * copyright osCommerce 2017
  */

if (! defined('MASTER_PASS')) { // not installed
  $query = tep_db_query("SELECT MAX(sort_order) AS last FROM " . TABLE_CONFIGURATION . " WHERE configuration_group_id = 1");
	$row = tep_db_fetch_array($query);
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) values ('Master Password', 'MASTER_PASS', 'DefaultPassword', 'This password will allow you to login to any customers account.', 1, '".($row['last']+1)."', now(),'sew_use_master_pass','sew_set_master_pass(')");
  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, date_added) values ('Master Password Migrated', 'MASTER_PASS_UPD', 'done', 'flag that upgrade has been performed', 6, now())");
} elseif (! defined('MASTER_PASS_UPD')) { // already installed but not updated
  tep_db_query("update " . TABLE_CONFIGURATION . " SET use_function = 'sew_use_master_pass', set_function = 'sew_set_master_pass(' WHERE configuration_key = 'MASTER_PASS'");
}

if (! function_exists('sew_use_master_pass')) {
  function sew_use_master_pass () {
	  return MASTER_PASSWORD_TEXT;
	}
}

if (! function_exists('sew_set_master_pass')) {
  function sew_set_master_pass () {
		$query = tep_db_query("SELECT configuration_id FROM " . TABLE_CONFIGURATION . " WHERE configuration_key = 'MASTER_PASS'");
		$row = tep_db_fetch_array($query);
		$output = '</td></tr></table></form><style type="text/css">#tdb2 {display: none;}</style>
<table cellspacing="0" cellpadding="2" border="0" width="100%"><tr><td class="infoBoxContent">';

		$output .= tep_draw_form('set_password','sew_utils.php');
		$output .= tep_draw_password_field('password','',true);
		$output .= tep_draw_button(TEXT_ENCRYPT_PASSWORD,'locked',null,'primary');
		$output .= tep_draw_hidden_field('var','MASTER_PASS');
		$output .= tep_draw_hidden_field('action','encrypt_var');
		$output .= tep_draw_hidden_field('return','configuration.php');
		$output .= tep_draw_hidden_field('param_string','gID=1&cID='.$row['configuration_id']);
		return $output;
	}
}